/* 
 *  Lsystem version 1.1, Copyright (C) 1994 G. Hutchings
 *  Lsystem comes with ABSOLUTELY NO WARRANTY.
 *  This is free software, and you are welcome to redistribute it
 *  under certain conditions; see the file COPYING for details.
 */

#define MIN(x, y)	((x) < (y) ? (x) : (y))
#define MAX(x, y)	((x) > (y) ? (x) : (y))

/* Memory allocator */
#define ALLOC(type, num)	(type *) malloc((unsigned)((num)*sizeof(type)))
#define REALLOC(var, type, num)	(type *) realloc((char *) var, \
					 (unsigned) ((num)*sizeof(type)))
#define DEALLOC(var)		free(var)

/* Initial max. no. of commands */
#define MAX_CMDS	1000

/* PostScript parameters */
#define PS_XLEN		597.6	 /* 8.3 inches */
#define PS_YLEN		842.4	 /* 11.7 inches */
#define PS_FLUSH	30	 /* path flush limit */

/* Functions */
void	do_gnuplot();
void	do_postscript();
void	error(char *file, int line, char *msg);
void	fatal(char *msg);
void	usage();
double	atof(char *str);

struct lang {
    char *name;			 /* command-line name */
    void (*func)();		 /* drawing function */
} languages[] = {
    "gnuplot",	do_gnuplot,
    "ps",	do_postscript,
    NULL,	NULL,
};

struct cmd {
    char name;			 /* command name */
    double arg1, arg2, arg3;	 /* arguments */
};
