%{
/* 
 *  Lsystem version 1.1, Copyright (C) 1994 G. Hutchings
 *  Lsystem comes with ABSOLUTELY NO WARRANTY.
 *  This is free software, and you are welcome to redistribute it
 *  under certain conditions; see the file COPYING for details.
 */

/* Input parser */

#include <stdio.h>
#include "defs.h"

extern char errbuf[];		/* error buffer */
%}

%union {
    int tval;			/* token */
    int ival;			/* integer */
    double dval;		/* real */
    char cval;			/* character */
    char sval[MAX_STR_LEN];	/* string */
}

%token <tval> INIT COLOUR EQUALS BECOMES
%token <ival> INUM
%token <dval> RNUM
%token <sval> STRING

%type  <cval> char
%type  <dval> real

%%

input		: /* empty */
		| input line
		;

line		: '\n'
		| init_def '\n'
		| colour_def '\n'
		| macro_def '\n'
		| rule_def '\n'
		| error '\n' { yyerrok; }
		;

init_def	: INIT STRING INUM real
		{
			initialize($2, $3, $4);
		}
		;

colour_def	: COLOUR char real real real
		{
			addcolour($2, $3, $4, $5);
		}
		;

macro_def	: char EQUALS STRING
		{
			addmacro($1, $3);
		}
		;

rule_def	: char BECOMES STRING
		{
			addrule($1, $3);
		}
		;

char		: STRING
		{
			$$ = $1[0];
			if (strlen($1) > 1) {
				sprintf(errbuf, "invalid character: %s", $$);
				yyerror(errbuf);
			}
		}
		;

real		: RNUM
		| INUM
		{
			$$ = (double) $1;
		}
		;
