%{
/* 
 *  Lsystem version 1.1, Copyright (C) 1994 G. Hutchings
 *  Lsystem comes with ABSOLUTELY NO WARRANTY.
 *  This is free software, and you are welcome to redistribute it
 *  under certain conditions; see the file COPYING for details.
 */

/* Input scanner */

#include "defs.h"
#include "parse.h"

extern int line_num;		 /* input line number */

char errbuf[MAX_STR_LEN];	 /* error buffer */
%}

DIGIT		[0-9]
INTEGER		-?{DIGIT}+
REAL		-?{DIGIT}*\.{DIGIT}+
WHITE		[ \t]+
SINGLE		[A-Za-z\[\]\+\-]

%%

\n		{
			line_num++;
			return yytext[0];
		}

#.*		;	/* ignore comments */

{WHITE}		;	/* strip whitespace */

init		{
			return INIT;
		}

col		{
			return COLOUR;
		}

=		{
			return EQUALS;
		}

->		{
			return BECOMES;
		}

{INTEGER}	{
			yylval.ival = atoi(yytext);
			return INUM;
		}

{REAL}		{
			yylval.dval = atof(yytext);
			return RNUM;
		}

{SINGLE}+	{
			strcpy(yylval.sval, yytext);
			return STRING;
		}

.		{
			sprintf(errbuf, "invalid character: %s", yytext);
			yyerror(errbuf);
		}
